--- /dev/null	Mon Nov  6 02:54:35 2017
+++ new/usr/src/lib/libfakekernel/common/ksid.c	Mon Nov  6 02:54:35 2017
@@ -0,0 +1,68 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2012, 2015 by Delphix. All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
+ */
+
+#include <sys/sid.h>
+
+#include <umem.h>
+#include <strings.h>
+
+static char *
+ksid_strdup(const char *s)
+{
+	size_t len;
+	char *new;
+
+	len = strlen(s);
+	new = umem_alloc(len + 1, KM_SLEEP);
+	bcopy(s, new, len);
+	new[len] = '\0';
+
+	return (new);
+}
+
+static void
+ksid_strfree(char *s)
+{
+	umem_free(s, strlen(s) + 1);
+}
+
+ksiddomain_t *
+ksid_lookupdomain(const char *dom)
+{
+	ksiddomain_t *kd;
+
+	kd = umem_zalloc(sizeof (ksiddomain_t), UMEM_NOFAIL);
+	kd->kd_name = ksid_strdup(dom);
+	return (kd);
+}
+
+void
+ksiddomain_rele(ksiddomain_t *ksid)
+{
+	ksid_strfree(ksid->kd_name);
+	umem_free(ksid, sizeof (ksiddomain_t));
+}
--- old/usr/src/lib/libfakekernel/common/kstat.c	Mon Nov  6 02:54:35 2017
+++ new/usr/src/lib/libfakekernel/common/kstat.c	Mon Nov  6 02:54:35 2017
@@ -11,6 +11,7 @@
 
 /*
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <sys/types.h>
@@ -36,6 +37,11 @@
 
 /*ARGSUSED*/
 void
+kstat_named_init(kstat_named_t *knp, const char *name, uchar_t type)
+{}
+
+/*ARGSUSED*/
+void
 kstat_install(kstat_t *ksp)
 {}
 
@@ -42,4 +48,34 @@
 /*ARGSUSED*/
 void
 kstat_delete(kstat_t *ksp)
+{}
+
+/*ARGSUSED*/
+void
+kstat_waitq_enter(kstat_io_t *kiop)
+{}
+
+/*ARGSUSED*/
+void
+kstat_waitq_exit(kstat_io_t *kiop)
+{}
+
+/*ARGSUSED*/
+void
+kstat_runq_enter(kstat_io_t *kiop)
+{}
+
+/*ARGSUSED*/
+void
+kstat_runq_exit(kstat_io_t *kiop)
+{}
+
+/*ARGSUSED*/
+void
+kstat_waitq_to_runq(kstat_io_t *kiop)
+{}
+
+/*ARGSUSED*/
+void
+kstat_runq_back_to_waitq(kstat_io_t *kiop)
 {}
--- old/usr/src/lib/libfakekernel/common/mapfile-vers	Mon Nov  6 02:54:35 2017
+++ new/usr/src/lib/libfakekernel/common/mapfile-vers	Mon Nov  6 02:54:35 2017
@@ -11,6 +11,7 @@
 
 #
 # Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 #
@@ -43,8 +44,21 @@
 	copyinstr;
 	copystr;
 
+	bioerror;
+	biodone;
+	bioinit;
+	geterror;
+
+	cyclic_add;
+	cyclic_remove;
+	cyclic_reprogram;
+
 	crfree;
 	crgetuid;
+	crgetruid;
+	crgetgid;
+	crgetngroups;
+	crgetgroups;
 	crhold;
 
 	cv_broadcast;
@@ -55,6 +69,7 @@
 	cv_signal;
 	cv_timedwait;
 	cv_timedwait_sig;
+	cv_timedwait_hires;
 	cv_wait;
 	cv_wait_sig;
 
@@ -62,9 +77,12 @@
 	ddi_get_lbolt;
 	ddi_get_pid;
 	ddi_strtoul;
+	ddi_strtoull;
 
 	delay;
 
+	fm_panic;
+
 	fakekernel_cprintf	{ FLAGS = NODIRECT };
 	fakekernel_init;
 	fakekernel_putlog	{ FLAGS = NODIRECT };
@@ -75,6 +93,10 @@
 
 	hz;
 
+	highbit64;
+
+	issig;
+
 	kcred;
 	kiconv;
 	kiconv_close;
@@ -81,6 +103,7 @@
 	kiconv_open;
 
 	kmem_alloc;
+	kmem_asprintf;
 	kmem_cache_alloc;
 	kmem_cache_create;
 	kmem_cache_destroy;
@@ -93,10 +116,15 @@
 
 	kmutex_destroy;
 	kmutex_init;
+	kmutex_enter;
+	kmutex_exit;
 
 	ksema_destroy;
 	ksema_init;
 
+	ksid_lookupdomain;
+	ksiddomain_rele;
+
 	ksocket_accept;
 	ksocket_bind;
 	ksocket_bind_helper	{ FLAGS = NODIRECT };
@@ -120,13 +148,18 @@
 
 	kstat_create;
 	kstat_create_zone;
+	kstat_named_init;
 	kstat_delete;
 	kstat_install;
+	kstat_waitq_enter;
+	kstat_waitq_exit;
+	kstat_runq_enter;
+	kstat_runq_exit;
+	kstat_waitq_to_runq;
+	kstat_runq_back_to_waitq;
 
 	msec_per_tick;
 
-	mutex_enter;
-	mutex_exit;
 	mutex_owned;
 	mutex_owner;
 	mutex_tryenter;
@@ -165,10 +198,12 @@
 
 	strfree;
 
+	system_taskq;
 	system_taskq_fini;	
 	system_taskq_init;
 	taskq_create;
 	taskq_create_proc;
+	taskq_create_sysdc;
 	taskq_destroy;
 	taskq_dispatch;
 	taskq_dispatch_ent;
@@ -175,8 +210,15 @@
 	taskq_member;
 	taskq_wait;
 
+	thread_create;
 	thread_join;
+	thread_exit;
 
+	tsd_get;
+	tsd_set;
+	tsd_create;
+	tsd_destroy;
+
 	tick_per_msec;
 	tsignal;
 	uiomove;
--- old/usr/src/lib/libfakekernel/common/mutex.c	Mon Nov  6 02:54:36 2017
+++ new/usr/src/lib/libfakekernel/common/mutex.c	Mon Nov  6 02:54:36 2017
@@ -11,6 +11,7 @@
 
 /*
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 /*
@@ -51,7 +52,7 @@
 }
 
 void
-mutex_enter(kmutex_t *mp)
+kmutex_enter(kmutex_t *mp)
 {
 	VERIFY(0 == _lwp_mutex_lock(&mp->m_lock));
 	mp->m_owner = _curthread();
@@ -71,7 +72,7 @@
 }
 
 void
-mutex_exit(kmutex_t *mp)
+kmutex_exit(kmutex_t *mp)
 {
 	ASSERT(mp->m_owner == _curthread());
 	mp->m_owner = _KTHREAD_INVALID;
--- old/usr/src/lib/libfakekernel/common/printf.c	Mon Nov  6 02:54:36 2017
+++ new/usr/src/lib/libfakekernel/common/printf.c	Mon Nov  6 02:54:36 2017
@@ -22,6 +22,7 @@
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2012 by Delphix. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <sys/param.h>
@@ -123,6 +124,16 @@
 panic(const char *fmt, ...)
 {
 	va_list adx;
+
+	va_start(adx, fmt);
+	vpanic(fmt, adx);
+	va_end(adx);
+}
+
+void
+fm_panic(const char *fmt, ...)
+{
+	va_list adx;
 
 	va_start(adx, fmt);
 	vpanic(fmt, adx);
--- /dev/null	Mon Nov  6 02:54:36 2017
+++ new/usr/src/lib/libfakekernel/common/sys/cmn_err.h	Mon Nov  6 02:54:36 2017
@@ -0,0 +1,80 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
+/*	  All Rights Reserved	*/
+
+
+/*
+ * Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ *
+ * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2016 Joyent, Inc.
+ * Copyright 2017 RackTop Systems.
+ */
+
+#ifndef _SYS_CMN_ERR_H
+#define	_SYS_CMN_ERR_H
+
+#include <stdio.h>
+
+#if !defined(_ASM) && (defined(_KERNEL) || defined(_FAKE_KERNEL))
+#include <sys/va_list.h>
+#endif
+
+#include <sys/dditypes.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/* Common error handling severity levels */
+
+#define	CE_CONT		0	/* continuation		*/
+#define	CE_NOTE		1	/* notice		*/
+#define	CE_WARN		2	/* warning		*/
+#define	CE_PANIC	3	/* panic		*/
+#define	CE_IGNORE	4	/* print nothing	*/
+
+#if !defined(_ASM) && (defined(_KERNEL) || defined(_FAKE_KERNEL))
+
+/*PRINTFLIKE2*/
+extern void cmn_err(int, const char *, ...)
+    __KPRINTFLIKE(2);
+
+extern void vcmn_err(int, const char *, __va_list)
+    __KVPRINTFLIKE(2);
+
+/*PRINTFLIKE1*/
+extern void panic(const char *, ...)
+    __KPRINTFLIKE(1) __NORETURN;
+
+extern void vpanic(const char *, __va_list)
+    __KVPRINTFLIKE(1) __NORETURN;
+
+#endif /* !_ASM && (_KERNEL || _FAKE_KERNEL) */
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _SYS_CMN_ERR_H */
--- old/usr/src/lib/libfakekernel/common/sys/condvar.h	Mon Nov  6 02:54:36 2017
+++ new/usr/src/lib/libfakekernel/common/sys/condvar.h	Mon Nov  6 02:54:36 2017
@@ -26,6 +26,7 @@
 /*
  * Copyright (c) 2012 by Delphix. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 /*
@@ -78,6 +79,8 @@
 
 #define	TIME_RES_VALID(tr)	(tr >= TR_NANOSEC && tr < TR_COUNT)
 
+#define	CALLOUT_FLAG_ABSOLUTE	0x2
+
 /*
  * condition variable function prototypes
  */
@@ -87,6 +90,8 @@
 extern	void	cv_wait(kcondvar_t *, kmutex_t *);
 extern	void	cv_wait_stop(kcondvar_t *, kmutex_t *, int);
 extern	clock_t	cv_timedwait(kcondvar_t *, kmutex_t *, clock_t);
+extern	clock_t	cv_timedwait_hires(kcondvar_t *, kmutex_t *, hrtime_t, hrtime_t,
+    int);
 extern	clock_t	cv_reltimedwait(kcondvar_t *, kmutex_t *, clock_t, time_res_t);
 extern	int	cv_wait_sig(kcondvar_t *, kmutex_t *);
 extern	clock_t	cv_timedwait_sig(kcondvar_t *, kmutex_t *, clock_t);
--- old/usr/src/lib/libfakekernel/common/sys/cred.h	Mon Nov  6 02:54:36 2017
+++ new/usr/src/lib/libfakekernel/common/sys/cred.h	Mon Nov  6 02:54:36 2017
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  *
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -76,6 +77,9 @@
 extern zoneid_t crgetzoneid(const cred_t *);
 extern projid_t crgetprojid(const cred_t *);
 
+extern const gid_t *crgetgroups(const cred_t *);
+extern int crgetngroups(const cred_t *);
+
 #endif	/* _KERNEL */
 
 #ifdef	__cplusplus
--- old/usr/src/lib/libfakekernel/common/sys/mutex.h	Mon Nov  6 02:54:36 2017
+++ new/usr/src/lib/libfakekernel/common/sys/mutex.h	Mon Nov  6 02:54:36 2017
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 1991, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _SYS_MUTEX_H
@@ -73,6 +74,8 @@
 } pad_mutex_t;
 #endif	/* _KERNEL */
 
+extern char *volatile panicstr;  /* panic string pointer */
+
 #define	MUTEX_HELD(x)		(mutex_owned(x))
 #define	MUTEX_NOT_HELD(x)	(!mutex_owned(x) || panicstr)
 
@@ -83,12 +86,20 @@
 #define	mutex_init	kmutex_init
 #define	mutex_destroy	kmutex_destroy
 
+/*
+ * We want to avoid binding against the versions of these
+ * functions in libc which causes bad things to happen.
+ */
+#define mutex_enter	kmutex_enter
+#define mutex_exit	kmutex_exit
+
 extern	void	kmutex_init(kmutex_t *, char *, kmutex_type_t, void *);
 extern	void	kmutex_destroy(kmutex_t *);
 
-extern	void	mutex_enter(kmutex_t *);
+extern	void	kmutex_enter(kmutex_t *);
+extern	void	kmutex_exit(kmutex_t *);
+
 extern	int	mutex_tryenter(kmutex_t *);
-extern	void	mutex_exit(kmutex_t *);
 extern	int	mutex_owned(const kmutex_t *);
 
 extern	void *mutex_owner(const kmutex_t *);
--- old/usr/src/lib/libfakekernel/common/sys/proc.h	Mon Nov  6 02:54:37 2017
+++ new/usr/src/lib/libfakekernel/common/sys/proc.h	Mon Nov  6 02:54:37 2017
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -110,7 +111,19 @@
 extern struct plock p0lock;	/* p0's plock */
 extern struct pid pid0;		/* p0's pid */
 
+extern int issig(int);
+#define	ISSIG(thr, why)	issig(why)
 
+/* Reasons for calling issig() */
+
+#define	FORREAL		0	/* Usual side-effects */
+#define	JUSTLOOKING	1	/* Don't stop the process */
+
+extern	void	tsd_create(uint_t *, void (*)(void *));
+extern	void	tsd_destroy(uint_t *);
+extern	void	*tsd_get(uint_t);
+extern	int	tsd_set(uint_t, void *);
+
 /*
  * This is normally in sunddi.h but
  * I didn't want to drag that in here.
--- old/usr/src/lib/libfakekernel/common/taskq.c	Mon Nov  6 02:54:37 2017
+++ new/usr/src/lib/libfakekernel/common/taskq.c	Mon Nov  6 02:54:37 2017
@@ -25,6 +25,7 @@
 /*
  * Copyright 2012 Garrett D'Amore <garrett@damore.org>.  All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <sys/taskq_impl.h>
@@ -38,6 +39,9 @@
 #include <sys/sysmacros.h>
 #include <sys/unistd.h>
 
+/* avoid <sys/disp.h> */
+#define   maxclsyspri     99
+
 /* avoid <unistd.h> */
 extern long sysconf(int);
 
@@ -263,6 +267,15 @@
 	    minalloc, maxalloc, NULL, flags));
 }
 
+/*ARGSUSED*/
+taskq_t *
+taskq_create_sysdc(const char *name, int nthr, int minalloc,
+    int maxalloc, proc_t *proc, uint_t dc, uint_t flags)
+{
+	return (taskq_create_proc(name, nthr, maxclsyspri,
+	    minalloc, maxalloc, proc, flags));
+}
+
 /*ARGSUSED*/
 taskq_t *
 taskq_create_proc(const char *name, int nthreads, pri_t pri,
--- old/usr/src/lib/libfakekernel/common/thread.c	Mon Nov  6 02:54:37 2017
+++ new/usr/src/lib/libfakekernel/common/thread.c	Mon Nov  6 02:54:37 2017
@@ -11,11 +11,13 @@
 
 /*
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <sys/cmn_err.h>
 #include <sys/thread.h>
 #include <sys/zone.h>
+#include <sys/proc.h>
 
 #define	_SYNCH_H	/* keep out <synch.h> */
 #include <thread.h>
@@ -122,4 +124,29 @@
 {
 	thread_exit();
 	/* NOTREACHED */
+}
+
+void
+tsd_create(uint_t *keyp, void (*destructor)(void *))
+{
+	VERIFY0(thr_keycreate(keyp, destructor));
+}
+
+/*ARGSUSED*/
+void
+tsd_destroy(uint_t *keyp)
+{}
+
+void *
+tsd_get(uint_t key)
+{
+	void *value;
+
+	return (thr_getspecific(key, &value) ? NULL : value);
+}
+
+int
+tsd_set(uint_t key, void *value)
+{
+	return (thr_setspecific(key, value));
 }
--- old/usr/src/lib/libzfs/Makefile.com	Mon Nov  6 02:54:37 2017
+++ new/usr/src/lib/libzfs/Makefile.com	Mon Nov  6 02:54:37 2017
@@ -22,6 +22,7 @@
 # Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2016 Igor Kozhukhov <ikozhukhov@gmail.com>
 # Copyright (c) 2011, 2016 by Delphix. All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 LIBRARY= libzfs.a
@@ -70,8 +71,10 @@
 C99MODE=	-xc99=%all
 C99LMODE=	-Xc99=%all
 LDLIBS +=	-lc -lm -ldevid -lgen -lnvpair -luutil -lavl -lefi \
-	-ladm -lidmap -ltsol -lmd -lumem -lzfs_core -lcmdutils
-CPPFLAGS +=	$(INCS) -D_LARGEFILE64_SOURCE=1 -D_REENTRANT
+	-ladm -lidmap -ltsol -lmd -lumem -lzfs_core -lcmdutils \
+	-lfakekernel
+CPPFLAGS +=	$(INCS) -D_LARGEFILE64_SOURCE=1 -D_REENTRANT \
+	-D_TASKQUSER
 $(NOT_RELEASE_BUILD)CPPFLAGS += -DDEBUG
 
 # There's no lint library for zlib, so only include this when building
--- old/usr/src/lib/libzfs/common/libzfs.h	Mon Nov  6 02:54:37 2017
+++ new/usr/src/lib/libzfs/common/libzfs.h	Mon Nov  6 02:54:37 2017
@@ -22,7 +22,7 @@
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2011 Pawel Jakub Dawidek. All rights reserved.
- * Copyright (c) 2011, 2015 by Delphix. All rights reserved.
+ * Copyright (c) 2011, 2016 by Delphix. All rights reserved.
  * Copyright (c) 2012, Joyent, Inc. All rights reserved.
  * Copyright (c) 2013 Steven Hartland. All rights reserved.
  * Copyright (c) 2014 Integros [integros.com]
@@ -560,12 +560,11 @@
 	zfs_handle_t	**cb_handles;
 	size_t		cb_alloc;
 	size_t		cb_used;
-	boolean_t	cb_verbose;
-	int		(*cb_getone)(zfs_handle_t *, void *);
 } get_all_cb_t;
 
+void zfs_foreach_mountpoint(libzfs_handle_t *, zfs_handle_t **, size_t,
+    zfs_iter_f, void *, boolean_t);
 void libzfs_add_handle(get_all_cb_t *, zfs_handle_t *);
-int libzfs_dataset_cmp(const void *, const void *);
 
 /*
  * Functions to create and destroy datasets.
--- old/usr/src/lib/libzfs/common/libzfs_dataset.c	Mon Nov  6 02:54:37 2017
+++ new/usr/src/lib/libzfs/common/libzfs_dataset.c	Mon Nov  6 02:54:37 2017
@@ -54,6 +54,7 @@
 #include <idmap.h>
 #include <aclutils.h>
 #include <directory.h>
+#include <time.h>
 
 #include <sys/dnode.h>
 #include <sys/spa.h>
@@ -785,6 +786,7 @@
 void
 libzfs_mnttab_init(libzfs_handle_t *hdl)
 {
+	(void) mutex_init(&hdl->libzfs_mnttab_cache_lock, MUTEX_DEFAULT, NULL);
 	assert(avl_numnodes(&hdl->libzfs_mnttab_cache) == 0);
 	avl_create(&hdl->libzfs_mnttab_cache, libzfs_mnttab_cache_compare,
 	    sizeof (mnttab_node_t), offsetof(mnttab_node_t, mtn_node));
@@ -825,6 +827,7 @@
 		free(mtn);
 	}
 	avl_destroy(&hdl->libzfs_mnttab_cache);
+	(void) mutex_destroy(&hdl->libzfs_mnttab_cache_lock);
 }
 
 void
@@ -839,6 +842,7 @@
 {
 	mnttab_node_t find;
 	mnttab_node_t *mtn;
+	int ret = ENOENT;
 
 	if (!hdl->libzfs_mnttab_enable) {
 		struct mnttab srch = { 0 };
@@ -849,11 +853,11 @@
 		srch.mnt_special = (char *)fsname;
 		srch.mnt_fstype = MNTTYPE_ZFS;
 		if (getmntany(hdl->libzfs_mnttab, entry, &srch) == 0)
-			return (0);
-		else
-			return (ENOENT);
+			ret = 0;
+		return (ret);
 	}
 
+	(void) mutex_lock(&hdl->libzfs_mnttab_cache_lock);
 	if (avl_numnodes(&hdl->libzfs_mnttab_cache) == 0)
 		libzfs_mnttab_update(hdl);
 
@@ -861,9 +865,10 @@
 	mtn = avl_find(&hdl->libzfs_mnttab_cache, &find, NULL);
 	if (mtn) {
 		*entry = mtn->mtn_mt;
-		return (0);
+		ret = 0;
 	}
-	return (ENOENT);
+	(void) mutex_unlock(&hdl->libzfs_mnttab_cache_lock);
+	return (ret);
 }
 
 void
@@ -872,14 +877,16 @@
 {
 	mnttab_node_t *mtn;
 
-	if (avl_numnodes(&hdl->libzfs_mnttab_cache) == 0)
-		return;
-	mtn = zfs_alloc(hdl, sizeof (mnttab_node_t));
-	mtn->mtn_mt.mnt_special = zfs_strdup(hdl, special);
-	mtn->mtn_mt.mnt_mountp = zfs_strdup(hdl, mountp);
-	mtn->mtn_mt.mnt_fstype = zfs_strdup(hdl, MNTTYPE_ZFS);
-	mtn->mtn_mt.mnt_mntopts = zfs_strdup(hdl, mntopts);
-	avl_add(&hdl->libzfs_mnttab_cache, mtn);
+	(void) mutex_lock(&hdl->libzfs_mnttab_cache_lock);
+	if (avl_numnodes(&hdl->libzfs_mnttab_cache) != 0) {
+		mtn = zfs_alloc(hdl, sizeof (mnttab_node_t));
+		mtn->mtn_mt.mnt_special = zfs_strdup(hdl, special);
+		mtn->mtn_mt.mnt_mountp = zfs_strdup(hdl, mountp);
+		mtn->mtn_mt.mnt_fstype = zfs_strdup(hdl, MNTTYPE_ZFS);
+		mtn->mtn_mt.mnt_mntopts = zfs_strdup(hdl, mntopts);
+		avl_add(&hdl->libzfs_mnttab_cache, mtn);
+	}
+	(void) mutex_unlock(&hdl->libzfs_mnttab_cache_lock);
 }
 
 void
@@ -888,6 +895,7 @@
 	mnttab_node_t find;
 	mnttab_node_t *ret;
 
+	(void) mutex_lock(&hdl->libzfs_mnttab_cache_lock);
 	find.mtn_mt.mnt_special = (char *)fsname;
 	if ((ret = avl_find(&hdl->libzfs_mnttab_cache, (void *)&find, NULL))
 	    != NULL) {
@@ -898,6 +906,7 @@
 		free(ret->mtn_mt.mnt_mntopts);
 		free(ret);
 	}
+	(void) mutex_unlock(&hdl->libzfs_mnttab_cache_lock);
 }
 
 int
--- old/usr/src/lib/libzfs/common/libzfs_impl.h	Mon Nov  6 02:54:38 2017
+++ new/usr/src/lib/libzfs/common/libzfs_impl.h	Mon Nov  6 02:54:38 2017
@@ -22,7 +22,7 @@
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2011 Pawel Jakub Dawidek. All rights reserved.
- * Copyright (c) 2011, 2016 by Delphix. All rights reserved.
+ * Copyright (c) 2011, 2017 by Delphix. All rights reserved.
  */
 
 #ifndef	_LIBZFS_IMPL_H
@@ -33,6 +33,7 @@
 #include <sys/nvpair.h>
 #include <sys/dmu.h>
 #include <sys/zfs_ioctl.h>
+#include <synch.h>
 
 #include <libuutil.h>
 #include <libzfs.h>
@@ -73,6 +74,13 @@
 	int libzfs_storeerr; /* stuff error messages into buffer */
 	void *libzfs_sharehdl; /* libshare handle */
 	boolean_t libzfs_mnttab_enable;
+	/*
+	 * We need a lock to handle the case where parallel mount threads
+	 * are populating the mnttab cache simultaneously. The lock only
+	 * protects the integrity of of the avl tree, and does not protect
+	 * the contents of the mnttab entries themselves.
+	 */
+	mutex_t libzfs_mnttab_cache_lock;
 	avl_tree_t libzfs_mnttab_cache;
 	int libzfs_pool_iter;
 	topo_hdl_t *libzfs_topo_hdl;
